[Libguestfs] [PATCH nbdkit v2 3/3] tests: Add a simple test of nbdkit_export_name.

Richard W.M. Jones rjones at redhat.com
Thu Sep 12 21:01:05 UTC 2019


---
 tests/Makefile.am         |  3 ++
 tests/test-export-name.sh | 86 +++++++++++++++++++++++++++++++++++++++
 2 files changed, 89 insertions(+)

diff --git a/tests/Makefile.am b/tests/Makefile.am
index b5806bb..f54597b 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -395,6 +395,9 @@ endif HAVE_LIBGUESTFS
 # Test export flags.
 TESTS += test-eflags.sh
 
+# Test export name.
+TESTS += test-export-name.sh
+
 # common disk image shared with several tests
 if HAVE_GUESTFISH
 check_DATA += disk
diff --git a/tests/test-export-name.sh b/tests/test-export-name.sh
new file mode 100755
index 0000000..2f63911
--- /dev/null
+++ b/tests/test-export-name.sh
@@ -0,0 +1,86 @@
+#!/usr/bin/env bash
+# nbdkit
+# Copyright (C) 2019 Red Hat Inc.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions are
+# met:
+#
+# * Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# * Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# * Neither the name of Red Hat nor the names of its contributors may be
+# used to endorse or promote products derived from this software without
+# specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY RED HAT AND CONTRIBUTORS ''AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
+# THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
+# PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL RED HAT OR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+
+source ./functions.sh
+set -e
+set -x
+
+requires nbdsh --version
+requires stat --version
+
+sock=`mktemp -u`
+files="$sock exportname.pid"
+rm -f $files
+cleanup_fn rm -f $files
+
+# Create a sh plugin which echos the export name back in the device.
+start_nbdkit -P exportname.pid -U $sock \
+             sh - <<'EOF'
+case "$1" in
+    open)
+        h=`mktemp $tmpdir/disk-XXXXXX`
+        echo -n "$3" > $h
+        echo $h
+        ;;
+    get_size)
+        stat -c '%s' "$2"
+        ;;
+    pread)
+        dd if="$2" skip=$4 count=$3 iflag=skip_bytes,count_bytes
+        ;;
+    *) exit 2 ;;
+esac
+EOF
+
+# Try to read back various export names from the plugin.
+for e in "" "test" "/" "//" " " \
+         "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx"
+do
+    export e sock
+    nbdsh -c '
+import os
+
+e = os.environ["e"]
+h.set_export_name (e)
+h.connect_unix (os.environ["sock"])
+
+size = h.get_size ()
+print ("size=%r e=%r" % (size, e))
+assert size == len (e)
+
+# Zero-sized reads are not defined in the NBD protocol.
+if size > 0:
+    buf = h.pread (size, 0)
+    print ("buf=%r e=%r" % (buf, e))
+    assert buf.decode() == e
+'
+done
-- 
2.23.0




More information about the Libguestfs mailing list